import java.io.*;
import java.util.*;
import java.text.*;


/**
 * The control panel for the application.
 */ 
public class ControlPanel {

    public static Date NOW;


    /**
     * Creates the control panel.
     */
    public ControlPanel() throws IOException {

	  FileWriter fw = new FileWriter("control-panel.html");
	  NOW = new Date();
	  int nST = ThreadManager.activeThreads;
	  int nAT = ThreadManager.existingThreads - ThreadManager.activeThreads;
	  int nTT = nST + nAT;

	  fw.write("<HTML>\n<HEAD>\n");
	  fw.write("<TITLE>Proxy Control Panel - " + NOW + "</TITLE>\n");
	  fw.write("</HEAD>\n<BODY BGCOLOR=\"#FFFF99\">\n<CENTER>\n");
	  fw.write("<H1>Proxy Control Panel</H1>\n");
	  fw.write("<TABLE COLS=2 WIDTH=70% CELLSPACING=10><TR>\n");
	  fw.write("<TD VALIGN=TOP NOWRAP>\n");
	  fw.write("Running on " + ProxyMain.PROXY_HOST + ", port " +
		   ProxyMain.PROXY_PORT + "<BR>\n");
	  fw.write("Started at " + ProxyMain.PROXY_STARTTIME + "<BR><BR>\n");
	  fw.write(nTT + " threads alive, " + nST + " serving, " +
		   nAT + " awaiting<BR>\n");
	  fw.write("thread range is [" + ProxyMain.MIN_THREADS +
		   "-" + ProxyMain.MAX_THREADS +
		   "], spare range is [" + ProxyMain.MIN_SPARE_THREADS +
		   "-" + ProxyMain.MAX_SPARE_THREADS + 
		   "]<BR>\n<BR>\n");
	  fw.write("Current time is " + NOW + " (update every " + 
		   ProxyMain.CONTROLPANEL_UPDATE_DELAY + " seconds)<BR>\n");
	  fw.write("</TD><TD ALIGN=CENTER NOWRAP>\n<H4>\n");
	  fw.write("<A HREF=\"in.cfg\">Client filters</A><BR>\n");
	  fw.write("<A HREF=\"out.cfg\">Server filters</A><BR><BR>\n");
	  fw.write("<A HREF=\"aut.cfg\">Authorizations</A><BR><BR>\n");
	  fw.write("<A HREF=\"" + ProxyMain.LOGFILE + 
		   "1.html\">Log</A><BR><BR>\n");
	  fw.write("<A HREF=\"" + ProxyMain.CFGFILE + 
		   "\">See RAMM configuration</A><BR>\n");
	  fw.write("<A HREF=\"form.html\">Change RAMM configuration</A><BR><BR>\n");
	  fw.write("</H4>\n</TD>\n</TR></TABLE>\n<BR><BR><BR>\n");
	  fw.write("<TABLE COLS=3 WIDTH=70%><TR VALIGN=TOP ALIGN=CENTER>\n");
	  fw.write("<TD></TD>\n");

	  fw.write("<TD><TABLE COLS=2 BORDER=1 CELLPADDING=5 CELLSPACING=5" +
		   "BGCOLOR=#EEEEEE>\n<TR><TH WIDTH=10 NOWRAP>Thread</TH>" +
		   "<TH WIDTH=10 NOWRAP>Status</TH></TR>\n");
	  int idx = 0;
	  if (nST > 0) {
	      for (idx = 0; idx < nST; idx++)
		  fw.write("<TR><TD>" + (idx + 1) + 
			   "</TD><TD NOWRAP><FONT COLOR=red>" + 
			   "serving client" + 
			   "</FONT></TD></TR>\n");
	  }
	  if (nAT > 0) {
	      for (; (idx - nST) < nAT; idx++)
		  fw.write("<TR><TD>" + (idx + 1) + 
			   "</TD><TD NOWRAP>" + 
			   "awaiting" + 
			   "</TD></TR>\n");
	  }
	  if (ProxyMain.MAX_THREADS - nTT > 0) {
	      fw.write("<TR><TD>" + (idx + 1) + " ... " + 
		       ProxyMain.MAX_THREADS +
		       "</TD><TD NOWRAP><FONT COLOR=gray>not alive" + 
		       "</FONT></TD></TR>\n");
	  }
	  fw.write("</TABLE></TD>\n<TD></TABLE>\n");

	  fw.write("</CENTER>\n</BODY>\n</HTML>\n");
	  fw.close();
      }
    

}
