import java.net.*;
import java.io.*;
import java.util.*;


/**
 * Stream reader for HTTP responses.
 */
public class HTTPResponseReader extends HTTPMessageReader {

    /** Status line: The status code, eg. 200, 404, etc. */
    String statusCode;


    /**
     * Retrieves a HTTP response message from the connection stream.
     * @param istream  the stream
     */
    public HTTPResponseReader(InputStream istream) 
	                           throws IOException, NoSuchElementException {
	DataInputStream distream = new DataInputStream(istream);

	retrieveHeader(distream);

	// We've got the header, let's parse it

	// Parses the status line
	StringTokenizer st = 
	    new StringTokenizer(new String(HTTPMessageReader.toArray(header)));
	versionProtocol = st.nextToken();
	statusCode = st.nextToken();
	String s;
	while (st.hasMoreTokens()) {
	    s = st.nextToken();
	    if (s.equals("Content-Length:"))
		contentLength = Integer.parseInt(st.nextToken());
	    if (s.equals("Connection:")) {
		connection = new String(st.nextToken());
		if (connection.equals("keep-alive")) mustCloseConnection = false;
	    }
	}

	retrieveBody(distream);	
    }

}
