import java.io.*;
import java.util.*;


/** The main functional proxy class. */
public class Proxy {

    private static boolean stop;
    private static ProxyConnection pc;
    private static long lastModifiedTime;


    public Proxy() throws IOException, InstantiationException, 
	                      IllegalAccessException, IllegalValuesException {

	pc = new ProxyConnection(ProxyMain.PROXY_PORT);
	pc.launch();
	Thread t = new Thread(timer());
	t.setDaemon(true);
	t.start();
	while (true) {
	    if (stop) break;
	    try {
		Thread.sleep(ProxyMain.CONTROLPANEL_UPDATE_DELAY*1000);
		ProxyMain.log.read();
		ProxyMain.log.generateSortedLogs(ProxyMain.LOGFILE);
		new ControlPanel();
	    }
	    catch (java.text.ParseException e1) {System.out.println(e1);}
	    catch (InterruptedException e2) {System.out.println(e2);}
	}
	System.out.println("Proxy terminated");
	(new File("proxy.tmp")).delete();
    }

   
    /**
     * Checks at a constant intervals whether the user modified the values
     * of the threads, or asked to stop the proxy.
     */
    static Runnable timer() {
	return new Runnable() {
		public void run() {
		    Properties p = new Properties();
		    FileInputStream f;
		    while (true) {
			try {
			    try {
				Thread.sleep(ProxyMain.CFG_CHECK_INTERVAL 
					     * 1000);
			    }
			    catch (InterruptedException e1) {continue;}

			    long fileTime = 
				(new File("proxy.tmp")).lastModified();
			    // if the date of file is the same of the date
			    // of the last access, do nothing
			    if (fileTime == lastModifiedTime) 
				continue;  
			    
			    lastModifiedTime = fileTime;
			    f = new FileInputStream("proxy.tmp");
			    p.load(f);
			    f.close();
			    ProxyMain.MIN_THREADS = 
				Integer.parseInt(p.getProperty("min-threads"));
			    ProxyMain.MAX_THREADS = 
				Integer.parseInt(p.getProperty("max-threads"));
			    ProxyMain.MIN_SPARE_THREADS = 
				Integer.parseInt(p.getProperty(
						         "min-spare-threads"));
			    ProxyMain.MAX_SPARE_THREADS = 
				Integer.parseInt(p.getProperty(
							 "max-spare-threads"));
			    pc.setAttributs(ProxyMain.MAX_THREADS,
					    ProxyMain.MIN_THREADS,
					    ProxyMain.MAX_SPARE_THREADS,
					    ProxyMain.MIN_SPARE_THREADS);
			    if (p.getProperty("stop").equals("on")) 
				stop = true;
			}
			catch (FileNotFoundException e2) {}
			catch (IOException e3) {System.out.println(e3);}
			catch (IllegalValuesException e4) {
			    System.out.println(e4);}
		    }
		}
	    };
    }


}

